/* -*-c-*-
 *
 * $Id: fipstest.h,v 1.3 2000/12/06 20:33:27 mdw Exp $
 *
 * FIPS140 randomness tests
 *
 * (c) 2000 Straylight/Edgeware
 */

/*----- Licensing notice --------------------------------------------------* 
 *
 * This file is part of Catacomb.
 *
 * Catacomb is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * Catacomb is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 * 
 * You should have received a copy of the GNU Library General Public
 * License along with Catacomb; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

/*----- Revision history --------------------------------------------------* 
 *
 * $Log: fipstest.h,v $
 * Revision 1.3  2000/12/06 20:33:27  mdw
 * Make flags be macros rather than enumerations, to ensure that they're
 * unsigned.
 *
 * Revision 1.2  2000/08/11 21:34:34  mdw
 * Change to use the new thresholds given in the draft FIPS140-2.
 *
 * Revision 1.1  2000/06/17 10:55:38  mdw
 * FIPS 140-1 random generator test.
 *
 */

#ifndef CATACOMB_FIPSTEST_H
#define CATACOMB_FIPSTEST_H

#ifdef __cplusplus
  extern "C" {
#endif

/*----- Header files ------------------------------------------------------*/

#include <mLib/bits.h>

/*----- Magic numbers -----------------------------------------------------*/

#define FIPSTEST_BUFSZ 2500

#define FIPSTEST_OK 0u
#define FIPSTEST_MONOBIT 1u
#define FIPSTEST_POKER 2u
#define FIPSTEST_RUNS 4u
#define FIPSTEST_LONGRUNS 8u

/*----- Functions provided ------------------------------------------------*/

/* --- @fipstest@ --- *
 *
 * Arguments:	@const octet *p@ = pointer to a buffer of @FIPSTEST_BUFSZ@
 *			bytes
 *
 * Returns:	Zero if OK, or a bitmask of failed tests.
 *
 * Use:		Performs the FIPS140 randomness tests on a block of data.
 */

extern unsigned fipstest(const octet */*p*/);

/*----- That's all, folks -------------------------------------------------*/

#ifdef __cplusplus
  }
#endif

#endif
